{********************************************************}
{ TOpenDialogEx, TSaveDialogEx components                }
{ Version 1.0                                            }
{ Copyright (C) 2001, Nick Rymanov. All Rights Reserved. }
{ nrimanov@netscape.net                                  }
{********************************************************}

unit unit_DialogsEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, CommDlg, Dialogs, Dlgs;

type
  TOpenDialogEx = class(TOpenDialog)
  protected
    function TaskModalDialog(DialogFunc: Pointer; var DialogData): Bool; override;
  end;

  TSaveDialogEx = class(TOpenDialogEx)
  public
    function Execute: Boolean; override;
  end;

procedure Register;

implementation

{$R *.RES}

type
  TOpenFileNameExA = packed record
    ofn : TOpenFilename;
    // (_WIN32_WINNT >= 0x0500)
    pvReserved : Pointer;
    dwReserved : DWORD;
    FlagsEx : DWORD;
  end;

function TOpenDialogEx.TaskModalDialog(DialogFunc: Pointer; var DialogData): Bool;

  function IsWin2000orMe : boolean;
  var
    ver : TOSVersionInfo;
  begin
    Result := False;
    ver.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
    if GetVersionEx(ver) then
      Result := (ver.dwPlatformId = VER_PLATFORM_WIN32_NT) and (ver.dwMajorVersion >= 5) or
                (ver.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS) and (ver.dwMajorVersion >= 4) and (ver.dwMinorVersion >= 90);
  end;

var
  ofn : TOpenFileNameExA;
begin
  FillChar(ofn, SizeOf(ofn), 0);

  ofn.ofn := TOpenFileName(DialogData);
  if IsWin2000orMe then
    ofn.ofn.lStructSize := SizeOf(ofn);

  Result := inherited TaskModalDialog(DialogFunc, ofn);

  TOpenFileName(DialogData) := ofn.ofn;
end;

{ TSaveDialogEx }

function TSaveDialogEx.Execute: Boolean;
begin
  Result := DoExecute(@GetSaveFileName);
end;

procedure Register;
begin
  RegisterComponents('Dialogs', [TOpenDialogEx, TSaveDialogEx]);
end;

end.

